#include <iostream>

#include "cBoard.h"
#include "constants.h"
#include "cNode.h"

cNode::cNode(cBoard* startBoard, bool turn) {
    currentBoard = startBoard;
    scoreSet = false;
    nodes = NULL;

    currentBoard->evaluate();

    if (currentBoard->getScore() == INT_PCWIN || currentBoard->getScore() == INT_PLAYERWIN || !(currentBoard->turnPossible())) {
        bestMove = currentBoard;
        scoreOfBest = currentBoard->getScore();
    } else {
        generateMoves(startBoard, turn);

        nodes = new cNode*[amountOfMoves];
        for (int i = 0; i < amountOfMoves; i++) {
            nodes[i] = new cNode(&possibleMoves[i], !turn);
            if (!scoreSet) {
                scoreOfBest = nodes[i]->getBestScore();
                bestMove = nodes[i]->getNodeBoard();
                scoreSet = true;
            } else {
                if (turn == TURN_PC) {
                    if (nodes[i]->getBestScore() > scoreOfBest) {
                        scoreOfBest = nodes[i]->getBestScore();
                        bestMove = nodes[i]->getNodeBoard();
                    }
                } else if (turn == TURN_PLAYER) {
                    if (nodes[i]->getBestScore() < scoreOfBest) {
                        scoreOfBest = nodes[i]->getBestScore();
                        bestMove = nodes[i]->getNodeBoard();
                    }
                }
            }
        }



        /*
        for (int i = 0; i < amountOfMoves; i++) {
            if (!scoreSet) {
                scoreOfBest = possibleMoves[i].getScore();
                bestMove = &possibleMoves[i];
                scoreSet = !scoreSet;
            } else {
                if (possibleMoves[i].getScore() > scoreOfBest) {
                    scoreOfBest = possibleMoves[i].getScore();
                    bestMove = &possibleMoves[i];
                }
            }
        }
        */
    }
}

cNode::~cNode () {

}

int cNode::generateMoves(cBoard* startBoard, bool turn) {
    amountOfMoves = 0;

    for (int y = 0; y < 3; y++) {
        for (int x = 0; x < 3; x++) {
            if (startBoard->getPos(x, y) == INT_EMPTY) {
                amountOfMoves++;
            }
        }
    }

    possibleMoves = new cBoard[amountOfMoves];
    int emptyCount = 0;
    bool done = false;

    for (int i = 0; i < amountOfMoves; i++) {
        possibleMoves[i].setField(startBoard);
        emptyCount = 0;
        done = false;

        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 3; x++) {
                if (possibleMoves[i].getPos(x, y) == INT_EMPTY && emptyCount == i && !done) {
                    if (turn == TURN_PC) {
                        possibleMoves[i].setPos(x, y, INT_PC);
                    } else if (turn == TURN_PLAYER) {
                        possibleMoves[i].setPos(x, y, INT_PLAYER);
                    }
                    done = true;
                } else if (possibleMoves[i].getPos(x, y) == INT_EMPTY && !(emptyCount == i)) {
                    emptyCount++;
                }
            }
        }
    }

    return 0;
}

int cNode::getBestScore() {
    return scoreOfBest;
}

cBoard* cNode::getBestMove() {
    return bestMove;
}

cBoard* cNode::getNodeBoard() {
    return currentBoard;
}
