#include <iostream>
#include <string>
#include <stdlib.h>

#include "cBoard.h"
#include "constants.h"
#include "cNode.h"

int playGame();

int main () {
    std::cout << "Tic Tac Toe V2.0\n";
    std::cout << "Coded by Frostbite / Bob Rubbens\n";
    std::cout << "To close the game at any time, just type 88.\n\n";

    playGame();

    return 0;
}

int playGame() {
    int gameLoop = 20;
    int t;
    int placeCounter = 0;
    bool turn = TURN_PLAYER;
    cBoard mainBoard(0, 0, 0, 0, 0, 0, 0, 0, 0);
    cNode* mainNode = NULL;

    std::cout << "Who may start? 0 = you, 1 = PC: ";
    std::cin >> turn;

    while (gameLoop != 88) {
        if (mainBoard.turnPossible() == false) {
            mainBoard.print();
            std::cout << "Tie!\nType 88 to close";
            std::cin >> t;
            gameLoop = 88;
        } else if (mainBoard.getScore() == INT_PLAYERWIN) {
            mainBoard.print();
            std::cout << "You win!\nType 88 to close";
            std::cin >> t;
            gameLoop = 88;
        } else if (mainBoard.getScore() == INT_PCWIN) {
            mainBoard.print();
            std::cout << "PC wins (lol)\nType 88 to close";
            std::cin >> t;
            gameLoop = 88;
        } else if (turn == TURN_PLAYER) {
            std::cout << "\nThis is the current game situation:\n";
            mainBoard.print();
            std::cout << "Type the # of the square where you want to put the O: ";
            std::cin >> gameLoop;

            placeCounter = 0;
            if (gameLoop != 88) {
                gameLoop--;
                for (int y = 0; y < 3; y++) {
                    for (int x = 0; x < 3; x++) {
                        if (placeCounter == gameLoop) {
                            if (mainBoard.getPos(x, y) > 0) {
                                std::cout << "That square is already in use!\n";
                            } else {
                                mainBoard.setPos(x, y, turn);
                                turn = TURN_PC;
                            }
                            placeCounter++;
                        } else {
                            placeCounter++;
                        }
                    }
                }
            }
        } else if (turn == TURN_PC) {
            mainNode = new cNode(&mainBoard, turn);
            mainBoard.setField(mainNode->getBestMove());
            turn = TURN_PLAYER;
            std::cout << "\n";
            delete mainNode;
        }
    }

    return 0;
}
